#ifndef BINTREE
#define BINTREE

#include <stdlib.h>
#include <stdio.h>

typedef struct bin_tree_cell
{
   int                  key;
   struct bin_tree_cell *lchild;
   struct bin_tree_cell *rchild;
}BinTreeCell, *BinTree_p;

void* SecureMalloc(size_t size);

#define BinTreeCellAlloc() SecureMalloc(sizeof(BinTreeCell))

void BinTreeInsert(BinTree_p *root, int key);
void BinTreeFree(BinTree_p root);
void BinTreePrintNatural(BinTree_p root);
void BinTreePrintPreorder(BinTree_p root);
void BinTreePrintPostorder(BinTree_p root);


#endif
